
/******************************************************************************
* MODULE     : algebraic_glue.hpp
* DESCRIPTION: Glue for algebraic extensions
* COPYRIGHT  : (C) 2007  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX_ALGEBRAIC_GLUE_HPP
#define __MMX_ALGEBRAIC_GLUE_HPP
#include "algebraic.hpp"
#include "category_meta.hpp"
#include "category_lift_glue.hpp"
namespace mmx {
#define TMPL template<typename C>
#define Algebraic algebraic<C>

TMPL Algebraic
make_algebraic (const polynomial<C>& p, const polynomial<C>& m) {
  return Algebraic (p, m, true);
}

template<typename Cond, typename C> void
define_algebraic () {
  define_type<Cond,Algebraic > (gen ("Algebraic", type_name<C> ()));
  define<Cond> ("algebraic", make_algebraic<C>);
  define_upgrader<Cond,Algebraic,C> ();

  lift_ring_ops<Cond,Algebraic,C> ();
  lift_scalar_ring_ops<Cond,Algebraic,C> ();
}

#undef TMPL
#undef Algebraic
} // namespace mmx
#endif // __MMX_ALGEBRAIC_GLUE_HPP
