
/******************************************************************************
* MODULE     : algebramix_glue.cpp
* DESCRIPTION: algebramix glue library
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "glue.hpp"
namespace mmx {

void define_standard_vector ();
void define_standard_matrix ();
void define_standard_polynomial ();
void define_standard_series ();
void define_standard_transseries ();
void define_standard_quotient ();
void define_standard_algebraic ();

void
define_standard_algebramix () {
  define_standard_vector ();
  define_standard_matrix ();
  define_standard_polynomial (); // after vectors
  define_standard_series ();
  define_standard_transseries ();
  define_standard_quotient (); // after polynomials
  define_standard_algebraic (); // after polynomials
}

} // namespace mmx

void (*define_algebramix) (void)= mmx::define_standard_algebramix;
