
/******************************************************************************
* MODULE     : quotient_glue.cpp
* DESCRIPTION: Standard glue for complexified numbers
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "quotient_glue.hpp"
#include "polynomial_glue.hpp"
#include "glue.hpp"
namespace mmx {
#define Polynomial polynomial<generic>
#define Rational_function quotient<Polynomial,Polynomial >

template<typename C> quotient<polynomial<C>,polynomial<C> >
scalar_polynomial_divide (const C& c, const polynomial<C>& p) {
  ASSERT (p != 0, "division by zero");
  return quotient<polynomial<C>,polynomial<C> > (polynomial<C> (c), p);
}

void
define_standard_quotient () {
  define_quotient<always,Polynomial,Polynomial >
    (gen ("Rational_function", GEN_GENERIC_TYPE));
  define<always> (GEN_OVER, scalar_polynomial_divide<generic>);
  lift_scalar_ring_ops<always,Rational_function,generic> ();
}

} // namespace mmx
