
/******************************************************************************
* MODULE     : quotient_glue.hpp
* DESCRIPTION: Glue for complexified numbers
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX_QUOTIENT_GLUE_HPP
#define __MMX_QUOTIENT_GLUE_HPP
#include "quotient.hpp"
#include "category_meta.hpp"
#include "category_lift_glue.hpp"
namespace mmx {
#define TMPL template<typename NT, typename DT>
#define Quotient quotient<NT,DT>

TMPL Quotient construct_quotient (const NT& x, const DT& y) {
  return Quotient (x, y, true); }
TMPL NT quotient_numerator (const Quotient& x) {
  return numerator (x); }
TMPL DT quotient_denominator (const Quotient& x) {
  return denominator (x); }

template<typename Cond, typename NT, typename DT> void
define_quotient (const generic& name) {
  define_type<Cond,Quotient > (name);
  define<Cond> (GEN_OVER, construct_quotient<NT,DT>);
  define_upgrader<Cond,Quotient,NT> ();
  define<Cond> (GEN_NUMERATOR, quotient_numerator<NT,DT>);
  define<Cond> (GEN_DENOMINATOR, quotient_denominator<NT,DT>);

  define_field<Cond,Quotient> ();
  lift_scalar_ring_ops<Cond,Quotient,NT> ();
  lift_ordering_ops<Cond,Quotient,NT> ();
}

#undef TMPL
#undef Quotient
} // namespace mmx
#endif // __MMX_QUOTIENT_GLUE_HPP
