
/******************************************************************************
* MODULE     : series_glue.cpp
* DESCRIPTION: Standard glue for series
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "rational_meta.hpp"
#include "floating_meta.hpp"
#include "jet_rational.hpp"
#include "jet_floating.hpp"
#include "series_glue.hpp"
namespace mmx {

class series_precision_rep: public alias_rep<int> {
  int prec;
public:
  inline series_precision_rep () {}
  int get () const { return get_series_precision (); }
  int& open () const { return *(const_cast<int*> (&prec)); }
  void close () const { set_series_precision (prec); }
};

void
define_standard_series () {
  static alias<int> prec= new series_precision_rep ();
  define_constant<always,alias<int> > ("series_precision", prec);

  define_series<always,generic> ();
  //define_series<always,rational> ();
  //define_series<always,floating<> > ();
}

} // namespace mmx
