
/******************************************************************************
* MODULE     : vector_format.hpp
* DESCRIPTION: Vector formatted black box data
* COPYRIGHT  : (C) 2007  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __VECTOR_FORMAT_HPP
#define __VECTOR_FORMAT_HPP
#include "format.hpp"
namespace mmx {
//namespace bbx {

struct vector_format_methods_rep: public format_methods_rep {
  vector_format_methods_rep ();
};

struct vector_format_rep: public format_rep {
  format f;  // coefficient format of vector
  nat    n;  // length of vector

  static vector_format_methods_rep mrep;
  inline vector_format_rep (const format& f2, nat n2):
    format_rep (n2 * f2->size, &mrep), f (f2), n (n2) {}
  inline ~vector_format_rep () {}
};

format
vector_format (const format& f, nat n) {
  return new vector_format_rep (f, n);
}

//} // namespace bbx
} // namespace mmx
#endif // __VECTOR_FORMAT_HPP
