
/******************************************************************************
* MODULE     : matrix_numeric_glue.cpp
* DESCRIPTION: Standard glue for numeric matrixs
* COPYRIGHT  : (C) 2007  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "numeric_extra.hpp"
#include "matrix_numeric.hpp"
#include "matrix_glue.hpp"
#include "rational_meta.hpp"
#include "complex_ball_meta.hpp"
namespace mmx {

void
define_matrix_numeric () {
  define_matrix<always,complex_ball> ();
  define_caster<always,matrix<complex_ball>,matrix<rational> >
    (PENALTY_CAST);
  define_caster<always,matrix<generic>,matrix<complex_ball> >
    (PENALTY_FALL_BACK);

  define<always> ("characteristic_polynomial",
		  characteristic_polynomial<complex_ball>);
  define<always> ("eigenvalues", eigenvalues<complex_ball>);
  define<always> ("eigenvectors", eigenvectors<complex_ball>);
  define<always> ("eigenspace", eigenspace<complex_ball>);
  define<always> ("eigenspaces", eigenspaces<complex_ball>);
}

} // namespace mmx
