
/******************************************************************************
* MODULE     : polynomial_numeric_glue.cpp
* DESCRIPTION: Standard glue for numeric polynomials
* COPYRIGHT  : (C) 2007  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "polynomial_glue.hpp"
#include "rational_meta.hpp"
#include "complex_ball_meta.hpp"
#include "numeric_polynomial.hpp"
#include "polynomial_roots.hpp"
namespace mmx {

void
define_polynomial_numeric () {
  define_polynomial<always,complex_ball> ();
  define_caster<always,polynomial<complex_ball>,polynomial<rational> >
    (PENALTY_CAST);
  define_caster<always,polynomial<generic>,polynomial<complex_ball> >
    (PENALTY_FALL_BACK);

  define<always> ("focus", focus<complex_ball>);
  define<always> ("roots", roots<complex_ball>);
  define<always> ("lower_bound_roots", lower_bound_roots<complex_ball>);
  define<always> ("upper_bound", upper_bound<complex_ball>);
  define<always> ("lower_bound", lower_bound<complex_ball>);
  define<always> ("upper_bound_re", upper_bound_real_part<complex_ball>);
}

} // namespace mmx
