
/******************************************************************************
* MODULE     : numeric_polynomial.hpp
* DESCRIPTION: Extra routines for numeric polynomials
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX_NUMERIC_POLYNOMIAL_HPP
#define __MMX_NUMERIC_POLYNOMIAL_HPP
#include "dense_polynomial.hpp"
namespace mmx {
#define TMPL template<typename C>
#define Real Real_type(C)
#define Radius Radius_type(C)
#define Polynomial polynomial<C>

TMPL Real lower_bound_roots (const Polynomial& P);
TMPL Real lower_bound_roots (const C* P, nat n, const Real& r, const Real& e);
TMPL Real maximum_disk (const C* P, nat n, const Real& r);
TMPL Real minimum_disk (const C* P, nat n, const Real& r);
TMPL Real maximum_real_part_disk (const C* P, nat n, const Real& r);

TMPL Real upper_bound (const Polynomial& P, const Real& r) {
  return maximum_disk (seg (P), N (P), r); }
TMPL Real lower_bound (const Polynomial& P, const Real& r) {
  return minimum_disk (seg (P), N (P), r); }
TMPL Real upper_bound_real_part (const Polynomial& P, const Real& r) {
  return maximum_real_part_disk (seg (P), N (P), r); }

#undef TMPL
#undef Real
#undef Radius
#undef Polynomial
} // namespace mmx
#endif // __MMX_NUMERIC_POLYNOMIAL_HPP
