
/******************************************************************************
* MODULE     : vector_numeric_glue.cpp
* DESCRIPTION: Standard glue for numeric vectors
* COPYRIGHT  : (C) 2007  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "vector_glue.hpp"
#include "rational_meta.hpp"
#include "complex_ball_meta.hpp"
namespace mmx {

void
define_vector_numeric () {
  define_vector<always,complex_ball> ();
  define_caster<always,vector<complex_ball>,vector<rational> >
    (PENALTY_CAST);
  define_caster<always,vector<generic>,vector<complex_ball> >
    (PENALTY_FALL_BACK);
}

} // namespace mmx
