
/******************************************************************************
* MODULE     : basix_globals.cpp
* DESCRIPTION: All public global variables for basix in appropriate order
* COPYRIGHT  : (C) 2007  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "list.hpp"
#include "basix_utils.hpp"
namespace mmx {

generic GEN_BEGIN ("begin");
generic GEN_BREAK ("break");
generic GEN_CASE ("case");
generic GEN_CONTINUE ("continue");
generic GEN_ELSE ("else");
generic GEN_ERROR ("error");
generic GEN_EXISTS ("exists");
generic GEN_FOR ("for");
generic GEN_FORALL ("forall");
generic GEN_GENERATE ("generate");
generic GEN_IF ("if");
generic GEN_IN ("in");
generic GEN_INFIX ("infix");
generic GEN_KEYWORD ("keyword");
generic GEN_LAMBDA ("lambda");
generic GEN_LOOP ("loop");
generic GEN_OPERATOR ("operator");
generic GEN_POSTFIX ("postfix");
generic GEN_PREFIX ("prefix");
generic GEN_RETURN ("return");
generic GEN_STEP ("step");
generic GEN_UNTIL ("until");
generic GEN_WHILE ("while");
generic GEN_YIELD ("yield");

generic GEN_DEFINE ("==");
generic GEN_ASSIGN (":=");
generic GEN_PLUS_ASSIGN ("+=");
generic GEN_MINUS_ASSIGN ("-=");
generic GEN_TIMES_ASSIGN ("*=");
generic GEN_OVER_ASSIGN ("/=");
generic GEN_DEFINE_MACRO ("==>");
generic GEN_ASSIGN_MACRO (":=>");
generic GEN_LESSLESS ("<<");
generic GEN_GTRGTR (">>");
generic GEN_IMPLIES ("=>");
generic GEN_EQUIV ("<=>");
generic GEN_OR ("\\/");
generic GEN_SEQOR ("or");
generic GEN_XOR ("xor");
generic GEN_AND ("/\\");
generic GEN_SEQAND ("and");
generic GEN_EQUAL ("=");
generic GEN_UNEQUAL ("!=");
generic GEN_LESS ("<");
generic GEN_LESSEQ ("<=");
generic GEN_GTR (">");
generic GEN_GTREQ (">=");
generic GEN_HAS ("has");
generic GEN_TYPE (":");
generic GEN_TRANSTYPE (":>");
generic GEN_INTO ("->");
generic GEN_MAPSTO (":->");
generic GEN_RANGE ("::");
generic GEN_RANGEEQ ("..");
generic GEN_PLUS ("+");
generic GEN_TIMES ("*");
generic GEN_OVER ("/");
generic GEN_DIV ("div");
generic GEN_MOD ("mod");
generic GEN_COMPOSE ("@");
generic GEN_SIZE ("#");
generic GEN_NOT ("!");
generic GEN_MINUS ("-");
generic GEN_POWER ("^");
generic GEN_FACTORIAL (".!");
generic GEN_PRIME (".'");
generic GEN_BACKPRIME (".`");
generic GEN_STAR (".*");
generic GEN_HAT (".^");
generic GEN_TILDA (".~");
generic GEN_DOT (".");
generic GEN_APPLY (".()");
generic GEN_ACCESS (".[]");
generic GEN_TUPLE ("()");
generic GEN_SQTUPLE ("[]");
generic GEN_ROW ("(.)");
generic GEN_COMMA (",");
generic GEN_SEMICOLON (";");
generic GEN_WHERE ("|");
generic GEN_VWHERE ("||");
generic GEN_BACKQUOTE ("`");
generic GEN_QUOTE ("'");

generic GEN_CATALAN ("mathcatalan");
generic GEN_D ("mathd");
generic GEN_DELTA ("delta");
generic GEN_E ("mathe");
generic GEN_EULER ("matheuler");
generic GEN_FALSE ("false");
generic GEN_FUZZ ("Fuzz");
generic GEN_I ("mathi");
generic GEN_INFINITY ("Infty");
generic GEN_NAN ("NaN");
generic GEN_NIL ("nil");
generic GEN_PARTIAL ("partial");
generic GEN_PI ("mathpi");
generic GEN_TRUE ("true");

generic GEN_HARD_EQ ("hard_eq");
generic GEN_HARD_NEQ ("hard_neq");
generic GEN_EQ ("eq");
generic GEN_NEQ ("neq");
generic GEN_MELT ("melt");
generic GEN_FUSE ("fuse");
generic GEN_NUMERATOR ("numerator");
generic GEN_DENOMINATOR ("denominator");
generic GEN_GCD ("gcd");
generic GEN_LCM ("lcm");
generic GEN_XGCD ("xgcd");
generic GEN_SQRT ("sqrt");
generic GEN_EXP ("exp");
generic GEN_LOG ("log");
generic GEN_COS ("cos");
generic GEN_SIN ("sin");
generic GEN_TAN ("tan");
generic GEN_ARCCOS ("arccos");
generic GEN_ARCSIN ("arcsin");
generic GEN_ARCTAN ("arctan");
generic GEN_MIN ("min");
generic GEN_MAX ("max");
generic GEN_ABS ("abs");
generic GEN_ARG ("arg");
generic GEN_RE ("Re");
generic GEN_IM ("Im");
generic GEN_CONJ ("conj");
generic GEN_SHARPEN ("sharpen");
generic GEN_DERIVE ("%derive");
generic GEN_DERIVATIVE ("derivative");
generic GEN_GRAD ("grad");
generic GEN_XDERIVE ("%xderive");
generic GEN_INTEGRATE ("integrate");
generic GEN_SUBSTITUTE ("substitute");
generic GEN_SOLVE ("solve");

generic GEN_ALIAS_TYPE ("Alias");
generic GEN_BOOLEAN_TYPE ("Boolean");
generic GEN_COMPOUND_TYPE ("Compound");
generic GEN_DOUBLE_TYPE ("Double");
generic GEN_FLOATING_TYPE ("Floating");
generic GEN_FUNCTION_TYPE ("Function");
generic GEN_GENERATOR_TYPE ("Generator");
generic GEN_GENERIC_TYPE ("Generic");
generic GEN_GENERIC_ALIAS_TYPE ("Generic_alias");
generic GEN_INT_TYPE ("Int");
generic GEN_INTEGER_TYPE ("Integer");
generic GEN_LITERAL_TYPE ("Literal");
generic GEN_RATIONAL_TYPE ("Rational");
generic GEN_SINGLE_TYPE ("Single");
generic GEN_SYMBOL_TYPE ("Symbol");
generic GEN_TUPLE_TYPE ("Tuple");
generic GEN_TYPE_TYPE ("Type");
generic GEN_UNKNOWN_TYPE ("Unknown");

generic GEN_ALIAS ("alias");
generic GEN_ALL_TYPES ("all_types");
generic GEN_CACHE_CONVERTER ("cache/converter");
generic GEN_CACHE_CONVERTERS ("cache/converters");
generic GEN_CACHE_PENALTY ("cache/penalty");
generic GEN_CAST ("cast");
generic GEN_CLOSURE ("closure");
generic GEN_CONVERT ("convert");
generic GEN_CONVERTER ("converter");
generic GEN_CONVERTERS ("converters");
generic GEN_DOWNGRADE ("downgrade");
generic GEN_EMPTY ("");
generic GEN_EQUALIZE_TUPLE ("equalize_tuple");
generic GEN_EXPECTED ("expected");
generic GEN_GLOBAL ("global");
generic GEN_IDENTITY ("identity");
generic GEN_LIST ("list");
generic GEN_LOCAL ("local");
generic GEN_MACRO ("macro");
generic GEN_NEW ("new");
generic GEN_NO_FLATTEN ("no_flatten");
generic GEN_PENALTY ("penalty");
generic GEN_RUNTIME_ERROR ("runtime error");
generic GEN_SPECIALIZE_ALIAS ("specialize_alias");
generic GEN_SPECIALIZE ("specialize");
generic GEN_TRANSITIVE ("transitive");
generic GEN_TYPE_NAME ("type_name");
generic GEN_TYPE_ID ("type_id");
generic GEN_UNALIAS ("unalias");
generic GEN_UPGRADE ("upgrade");
generic GEN_VIA_TUPLE ("via_tuple");

} // namespace mmx
