
/******************************************************************************
* MODULE     : table_glue.cpp
* DESCRIPTION: Standard glue for tables
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "table_glue.hpp"
#include "tuple.hpp"
namespace mmx {

alias<generic>
generic_table_element (const alias<table<generic,generic> >& a,
		       const tuple<generic>& key)
{
  return new table_element_rep<generic,generic> (a, as<generic> (key));
}

generic
generic_table_access (const table<generic,generic>& t,
		      const tuple<generic>& key)
{
  return t[as<generic> (key)];
}

void
define_standard_table () {
  define_table<always,generic, generic> ();
  define<always> (GEN_ACCESS, generic_table_access);
  define<always> (GEN_ACCESS, generic_table_element);
}

} // namespace mmx
