
/******************************************************************************
* MODULE     : row_tuple.hpp
* DESCRIPTION: Syntactic row_tuple type constructor
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __ROW_TUPLE_HPP
#define __ROW_TUPLE_HPP
#include "array.hpp"
#include "wrap.hpp"
namespace mmx {
#define TMPL template<typename C>
#define Row_tuple row_tuple<C>

/******************************************************************************
* The row_tuple class
******************************************************************************/

template<typename C>
class row_tuple {
MMX_ALLOCATORS
  generic rep;
public:
  inline generic operator * () const { return rep; }
  inline row_tuple (const generic& g): rep (g) {}
  inline row_tuple (const Row_tuple& t): rep (t.rep) {}
  inline C operator[] (nat i) const { return as<C> (rep[i+1]); }
};

TMPL generic
flatten (const Row_tuple& t) {
  return flatten (gen (GEN_ROW, cdr (compound_to_array (*t))));
}

WRAP_INDIRECT_IMPL(TMPL inline,Row_tuple)
PRINT_SUGAR(TMPL,Row_tuple)

TMPL inline nat N (const Row_tuple& t) { return N(*t)-1; }

#undef TMPL
#undef Row_tuple
} // namespace mmx
#endif // __ROW_TUPLE_HPP
