
/******************************************************************************
* MODULE     : exception.cpp
* DESCRIPTION: Syntactic exception type constructor
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "string.hpp"
#include "generic_internal.hpp"
namespace mmx {

exception::exception (const generic& msg, const generic& where):
  rep (gen (GEN_RUNTIME_ERROR, msg, where)) {}
exception::exception (const generic& msg, const generic& a, const generic& w):
  rep (gen (GEN_RUNTIME_ERROR, msg, a, w)) {}

generic
wrong_nr_args (const generic& where) {
  return as<generic> (exception ("wrong number of arguments", where));
}

generic
type_mismatch (const generic& expect, const generic& where) {
  return as<generic> (exception (GEN_EXPECTED, expect, where));
}

} // namespace mmx
