
/******************************************************************************
* MODULE     : cpp_syntax.hpp
* DESCRIPTION: C++ pretty printer
* COPYRIGHT  : (C) 2000  Joris van der Hoeven, 2007  Gregoire Lecerf
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __CPP_SYNTAX_HPP
#define __CPP_SYNTAX_HPP

#include <string.hpp>
#include <generic.hpp>

namespace mml {

void cpp_print (ostream& out, const generic& g);

extern string CPP_ACCESS;
extern string CPP_ALIAS;
extern string CPP_AND;
extern string CPP_APPLY;
extern string CPP_ARROW;
extern string CPP_ASSIGN;
extern string CPP_BEGIN;
extern string CPP_BITWISE_AND;
extern string CPP_BITWISE_OR;
extern string CPP_BITWISE_XOR;
extern string CPP_BOOL;
extern string CPP_BRACKETS;
extern string CPP_BREAK;
extern string CPP_CAST;
extern string CPP_CLASS;
extern string CPP_COMPLEMENT;
extern string CPP_CONST;
extern string CPP_CONSTRUCT;
extern string CPP_CONSTRUCTOR;
extern string CPP_CONTINUE;
extern string CPP_DELETE;
extern string CPP_DESTRUCTOR;
extern string CPP_DIV;
extern string CPP_DO;
extern string CPP_DOT;
extern string CPP_ELSE;
extern string CPP_EQUAL;
extern string CPP_EXIT;
extern string CPP_EXTERN;
extern string CPP_FOR;
extern string CPP_GTR;
extern string CPP_GTREQ;
extern string CPP_GTRGTR;
extern string CPP_IF;
extern string CPP_INHERIT;
extern string CPP_INITIALIZE;
extern string CPP_INLINE;
extern string CPP_INT;
extern string CPP_LESS;
extern string CPP_LESSEQ;
extern string CPP_LESSLESS;
extern string CPP_MINUS;
extern string CPP_MINUS_ASSIGN;
extern string CPP_MOD;
extern string CPP_MOD_ASSIGN;
extern string CPP_NAMESPACE;
extern string CPP_NEW;
extern string CPP_NOT;
extern string CPP_OR;
extern string CPP_OSTREAM;
extern string CPP_OVER;
extern string CPP_OVER_ASSIGN;
extern string CPP_PLUS;
extern string CPP_PLUS_ASSIGN;
extern string CPP_POINTER;
extern string CPP_POSTDEC;
extern string CPP_POSTINC;
extern string CPP_PREDEC;
extern string CPP_PREINC;
extern string CPP_PUBLIC;
extern string CPP_RETURN;
extern string CPP_SCOPE;
extern string CPP_SPECIALIZE;
extern string CPP_STATIC;
extern string CPP_STRING;
extern string CPP_STRUCT;
extern string CPP_SWITCH;
extern string CPP_TEMPLATE;
extern string CPP_TIMES;
extern string CPP_TIMES_ASSIGN;
extern string CPP_TYPE;
extern string CPP_TYPEDEF;
extern string CPP_UNALIAS;
extern string CPP_UNEQUAL;
extern string CPP_UNFUNCTION;
extern string CPP_UNPOINTER;
extern string CPP_USING;
extern string CPP_VERBATIM;
extern string CPP_VIRTUAL;
extern string CPP_VOID;
extern string CPP_WHILE;
extern string CPP_XOR;

} // namespace mml
#endif // __CPP_SYNTAX_HPP

