
/******************************************************************************
* MODULE     : mmx_syntax.hpp
* DESCRIPTION: Parser and pretty printer for Mathemagix
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX_SYNTAX_HPP
#define __MMX_SYNTAX_HPP
#include "string.hpp"
#include "list.hpp"
#include "mmx_identifiers.hpp"
#include "parse_tools.hpp"

namespace mmx {

int mmx_lex (generic* lval, parse_instance* obj);
  // lexicographic analyzer

generic mmx_parse (const string &file_name, nat input_number,
		   const string& s,
		   list<syntax_error>& errors);
  // Parse s.
  // input_number is relevant in the interactive mode only.
  // file_name == "" means stdin.

void mmx_print (ostream& out, const generic& g);

}
#endif // __MMX_SYNTAX_HPP
