
/******************************************************************************
* MODULE     : lisp_extra.cpp
* DESCRIPTION: Standard output facilities and switches
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "string.hpp"
#include "mmx_identifiers.hpp"
#include "evaluator.hpp"
#include "generic_internal.hpp"
namespace mmx {

nat      the_series_prec = 10;
nat      the_series_zt   = 25;
bool     the_series_expr = false;
void*    flatten_aux_ptr = NULL;

generic&
the_series_var () {
  static generic* ptr= NULL;
  if (ptr == NULL) ptr= mmx_new_one<generic> ("z");
  return *ptr;
  //static generic v ("z");
  //return v;
}

generic&
the_polynomial_var () {
  static generic* ptr= NULL;
  if (ptr == NULL) ptr= mmx_new_one<generic> ("x");
  return *ptr;
  //static generic v ("x");
  //return v;
}

generic flatten (bool b) {
  return b? generic ("true"): generic ("false"); }
generic flatten (int i) {
  if (current_ev->contains (gen (GEN_NO_FLATTEN, GEN_INT_TYPE)))
    return construct (as<generic> (i));
  return generic (as_string (i)); }
generic flatten (nat i) {
  if (current_ev->contains (gen (GEN_NO_FLATTEN, GEN_INT_TYPE)))
    return construct (as<generic> ((int) i));
  return generic (as_string (i)); }
generic flatten (float x) {
  if (current_ev->contains (gen (GEN_NO_FLATTEN, GEN_DOUBLE_TYPE)))
    return construct (as<generic> ((double) x));
  return generic (as_string (x)); }
generic flatten (double x) {
  if (current_ev->contains (gen (GEN_NO_FLATTEN, GEN_DOUBLE_TYPE)))
    return construct (as<generic> (x));
  return generic (as_string (x)); }
generic flatten (char* s) {
  return generic (s); }
generic flatten (const string& s) {
  return generic (s); }

} // namespace mmx
