
/******************************************************************************
* MODULE     : lisp_parser.cpp
* DESCRIPTION: Parsing lisp expressions
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "string.hpp"
#include "array.hpp"
#include "compound.hpp"
namespace mmx {

static generic
from_lisp (const string& s, nat& pos) {
  while (pos < N(s) && s[pos] == ' ') pos++;
  if (s[pos] == '(') {
    array<generic> v;
    pos++;
    while (pos < N(s) && s[pos] != ')') {
      v << from_lisp (s, pos);
      while (pos < N(s) && s[pos] == ' ') pos++;
    }
    if (pos < N(s)) pos++;
    return array_to_compound (v);
  }
  else {
    nat start= pos;
    while (pos < N(s) && s[pos] != ' ' && s[pos] != '(' && s[pos] != ')')
      pos++;
    return generic (s (start, pos));
  }
}

generic
from_lisp (const string& s) {
  nat pos= 0;
  return from_lisp (s, pos);
}

} // namespace mmx
