
/******************************************************************************
* MODULE     : lisp_printer.cpp
* DESCRIPTION: Printing lisp expressions
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "string.hpp"
#include "literal.hpp"
#include "compound.hpp"
namespace mmx {

void
lisp_print (ostream& out, const generic& g) {
  if (is<literal> (g)) out << literal_to_string (g);
  else if (is<compound> (g)) {
    nat i, n= N (g);
    out << "(";
    if (n>0) lisp_print (out, g[0]);
    for (i=1; i<n; i++) {
      out << " ";
      lisp_print (out, g[i]);
    }
    out << ")";
  }
  else {
    select_output_evaluator ();
    generic f= flatten (g);
    restore_evaluator ();
    lisp_print (out, f);
  }
}

} // namespace mmx
