<TeXmacs|1.0.6.10>

<style|mmxdoc>

<\body>
  <tmdoc-title|Design goals behind <value|mmx>>

  The main current design goals of <value|mmx> are as follows:

  <\description>
    <item*|Strong typedness><value|mmx> should be strongly typed, with
    support for overloading, implicit conversions, generic objects,
    compile-time type checking and, possibly, built-in support for expression
    types which interact with the type system.

    <item*|High level control structures><value|mmx> should support high
    level control structures, like coroutines, generators, exceptions,
    <abbr|etc.>. Our current approach is based on <name|Scheme>
    continuations. In the future we also wish to consider parallellism.

    <item*|Fast prototyping>It should be possible to write a good prototype
    for the language reasonably fast. In particular, it must be possible to
    write a reasonably fast interpreter for the language.

    <item*|Runtime efficiency>This is a really a long-term goal, since
    writing a compiler is not a short-term objective. Nevertheless, the
    possibility to write a compiler which produces efficient code should be
    kept in mind. In particular, the language should support directives for
    controlling memory layout and inlining in a way which is naturally
    compatible with the type system.

    <item*|Reusability of extern libraries>Before achieving runtime
    efficiency of <value|mmx> itself, we aim to achieve runtime efficiency
    through the extensive reuse of existing dedicated libraries written in
    other languages. <value|mmx> should therefore implement transparent
    mechanisms for reusing extern libraries and in particular C++ template
    libraries. Special care should be taken of garbage collection.

    <item*|Language independence>Via the concept of an ``abstract
    evaluator'', it should be possible to use the functionality provided by
    <value|mmx> libraries from within different high level languages,
    <verbatim|mmx-light> being the default interpreter.

    <item*|Good scalability>It should be possible to develop large computer
    algebra systems using <value|mmx> in a natural and modular way. Special
    attention should be paid to constructs for programming in the large and
    the type system should naturally allow extensions of types and code.
  </description>

  <tmdoc-copyright|2003|Joris van der Hoeven>

  <tmdoc-license|Permission is granted to copy, distribute and/or modify this
  document under the terms of the <hlink|GNU General Public
  License|http://www.gnu.org/licenses/gpl.txt>. If you don't have this file,
  write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.>
</body>