<TeXmacs|1.0.6.10>

<style|mmxdoc>

<\body>
  <tmdoc-title|The current <value|mmx> type system>

  Since 2006, the structure of <value|mmx> has been heavily reorganized and a
  new interpreter has been written. The type system of the new interpreter is
  a bit weaker than before in this respect that we no longer have template
  types. In the future, we wish to let the current type system evolve
  gradually towards the <hlink|ultimate <value|mmx> type
  system|mmx-types.en.tm>, which combines all good features of the past,
  present and future.

  The current type system also comes with a few improvements. First of all,
  it is now possible to define automatic converters. Such converters can be
  combined according to transtivity properties which may be declared by the
  user. Secondly, the new type system provides a generic type
  <verbatim|Generic>, together with an automatic converter
  <verbatim|T<nbsp>-\<gtr\> Generic> for any type <verbatim|T>.

  The mixture of a generic type with conventional strongly typed system
  raises some subtle, but interesting, questions:

  <\enumerate>
    <item>One has to be careful with automatic conversions: using converters
    <verbatim|T<nbsp>-\<gtr\> Generic> and <verbatim|Generic<nbsp>-\<gtr\>
    Vector Generic>, and similarly for <verbatim|Matrix Generic>,
    <verbatim|Series Generic>, <abbr|etc.>, any type <verbatim|T> can be
    converted into <verbatim|Vector Generic>. In particular, when
    implementing operations on <verbatim|Vector Generic>, one should avoid
    conversions of the scalars to <verbatim|Vector Generic>, which may cause
    infinite loops.

    Currently, the above problem is solved by attaching penalties to
    converters (and penalties are combined using <verbatim|max> rather than
    <verbatim|+>). The converter <verbatim|Generic<nbsp>-\<gtr\> Vector
    Generic> is used only if all other methods fail. However, we are
    generally not in favour of systems which are based on priorities. We
    intend to invent something cleaner in the future.

    <item>One of the reasons behind having a <verbatim|Generic> type is to
    gracefully combine a high level user interface with a powerful
    programming language. However, these two objectives sometimes conflict.
    For instance, consider the example <verbatim|2*(3/2)>; what should the
    return type be? The end-user sees <verbatim|3> and will assume the result
    to be an <verbatim|Integer>. However, from the programming point of view,
    returning a <verbatim|Rational> makes it possible to design more
    systematic algorithms.

    Our current view on the above problem is to allow for both possibilities:
    programmers may use a strongly typed language in which <verbatim|2*(3/2)>
    will explicitly be considered to be a <verbatim|Rational>. End-users
    rather rely on the <verbatim|Generic> type and printing
    <verbatim|2*(3/2)> will imply an automatic conversion
    <verbatim|Rational<nbsp>-\<gtr\> Generic>, which may actually simplify
    the rational into an integer. This mechanism has not been implemented and
    tested yet, but we hope to do this sometime soon.

    <item>When interfacing <value|mmx> with other systems which also provide
    generic types, it may be necessary to implement type equivalences between
    different types of generic objects. The current automatic conversion
    facility already makes it possible to define such type equivalences for
    ordinary types. More research has to be done in order to extend these
    priciples to generic types (in particular, because of the penalty
    system).
  </enumerate>

  <tmdoc-copyright|2007|Joris van der Hoeven>

  <tmdoc-license|Permission is granted to copy, distribute and/or modify this
  document under the terms of the <hlink|GNU General Public
  License|http://www.gnu.org/licenses/gpl.txt>. If you don't have this file,
  write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.>
</body>