<TeXmacs|1.0.6.10>

<style|mmxdoc>

<\body>
  <tmweb-current|Home|Download><tmdoc-title*|Downloading and installing
  <value|mmx>|<mmxweb-main-links>>

  <section|Architecture and prerequisites>

  <value|mmx> consists of a collection of smaller packages which partially
  depend on each other. Currently, the packages with dependencies are as
  follows:

  <\description>
    <item*|basix>Common architecture for <value|mmx>. Depends on nothing.

    <item*|mmxlight>The <value|mmx> interpreter. Depends on <verbatim|basix>
    and <hlink|readline|http://tiswww.case.edu/php/chet/readline/rltop.html>.

    <item*|gnumerix>Arithmetic on numbers. Depends on <verbatim|mmxlight>,
    <hlink|gmp|http://www.swox.com/gmp/> and
    <hlink|mpfr|http://www.mpfr.org/>.

    <item*|algebramix>Basic library for algebraic objects. Depends on
    <verbatim|gnumerix>.

    <item*|symbolix>Basic library for symbolic expressions. Depends on
    <verbatim|algebramix>.

    <item*|analyzit>Basic library for analytic objects. Depends on
    <verbatim|algebramix>.
  </description>

  The external dependencies are <hlink|readline|http://tiswww.case.edu/php/chet/readline/rltop.html>,
  <hlink|gmp|http://www.swox.com/gmp/> and <hlink|mpfr|http://www.mpfr.org/>.
  Notice that <verbatim|mmxlight> can be compiled independently from
  <verbatim|readline>, but the resulting command-line interface will be
  minimalistic.

  <section|Download and unpack the source code>

  Download the <hlink|latest version|ftp://ftp.mathemagix.org/pub/mathemagix/targz>
  of the source code, cd into the directory where you wish to compile
  <value|mmx> and type

  <code| \ \ \ tar -zxvf Mathemagix-[source version]-src.tar.gz>

  All files will be unpacked into the directory
  <with|font-family|tt|Mathemagix-[version]-src>, which is the 'installation
  directory'. The up-to-date development version is also available by
  <hlink|CVS|cvs.en.tm>.

  <section|Compile and install>

  Cd into the installation directory and do the usual:

  <\code>
    \ \ \ \ ./configure

    \ \ \ \ make

    \ \ \ \ make install
  </code>

  in order to install in <verbatim|/usr/local>. If you want to install
  elsewhere, then use

  <\code>
    \ \ \ \ ./configure --prefix=[other-dir]
  </code>

  Notice that each individual package can be compiled and installed
  independently using the same procedure. In particular, this allows you to
  build only that part of <value|mmx> which is actually useful for you.
  Packagers are incited not to ship <value|mmx> as one big package, but
  rather as the collection of the individual packages.

  <section|Run>

  After installation, you should now have the binary
  <with|font-family|tt|mmx-light> in your path. The interpreter is launched
  using

  <code| \ \ \ mmx-light>

  Typing

  <code| \ \ \ derive (x^x^x, x)>

  at the prompt should produce the output

  <\code>
    \ \ \ \ x^(x^x) * (x^x * log (x) * (log (x) + 1) + x^(x - 1))
  </code>

  <tmdoc-copyright|2003|Joris van der Hoeven>

  <tmdoc-license|Permission is granted to copy, distribute and/or modify this
  document under the terms of the <hlink|GNU General Public
  License|http://www.gnu.org/licenses/gpl.txt>. If you don't have this file,
  write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.>
</body>