<TeXmacs|1.0.6.10>

<style|mmxdoc>

<\body>
  <tmweb-current|Home|Progress><tmdoc-title*|Progress on
  <value|mmx>|<mmxweb-main-links>>

  <section|<with|font-series|bold|What has been done>>

  <\description>
    <item*|Basix>

    <\itemize>
      <item>Basic data types: symbols, lists, arrays, hash tables, etc.

      <item>A system for generic objects.

      <item>Parsers and pretty printers, together with a system for keeping
      track of locations in the source code and generating error messages.

      <item>Important operators and categories for systematic use throughout
      the project.

      <item>The <value|mmx> glue facility, both for interpreters and
      functionality.
    </itemize>

    <item*|Mmxlight>

    <\itemize>
      <item>The basic interpreter: most control structures, declarations,
      function applications, loading files and dynamic libraries.

      <item>A rudimentary type system with overloading, implicit conversion
      and a first form of genericity based on the <verbatim|generic> type.

      <item>An <name|Emacs> mode for <value|mmx>.
    </itemize>

    <item*|Gnumerix>

    <\itemize>
      <item>Interfaces with <name|Gmp> and <name|Mpfr>.

      <item>Complexified numbers.

      <item>Intervals and balls for certified arithmetic.

      <item>Wrapper above intervals or balls for computable numbers.
    </itemize>

    <item*|Algebramix>

    <\itemize>
      <item>Vectors, matrices and dense polynomials.

      <item>A start of modular arithmetic, algebraic numbers and quotient
      structures.

      <item>Skew polynomials.

      <item>Formal power series and a start of transseries and moulds.
    </itemize>

    <item*|Symbolix>

    <\itemize>
      <item>Basic arithmetic on symbolic expressions.

      <item>Basic calculus: differentiation, substitution and an overly
      simple solver.
    </itemize>

    <item*|Analyzit>

    <\itemize>
      <item>Some first and improvable routines for numerical matrices and
      polynomials.

      <item>Some basic utilities for holonomic functions.

      <item>First slow version of analytic functions and analytic
      continuation.
    </itemize>
  </description>

  <section|<with|font-series|bold|What has to be done>>

  <\description>
    <item*|Basix>

    <\itemize>
      <item>Dispatch frequently used functions (addition, multiplication,
      etc.) from generic type.
    </itemize>

    <item*|Mmxlight>

    <\itemize>
      <item>Template types (as in an older version of the interpreter, which
      did not have generic types or implicit type conversion).

      <item>User definable types and modules.

      <item>Full exception system.

      <item>Higher level constructs such as (limited) generators,
      continuations.

      <item>Make the interpreter more efficient (byte-code?).

      <item>Writing a compiler.
    </itemize>

    <item*|Gnumerix>

    <\itemize>
      <item>More semantics and several types of semantics for interval and
      ball arithmetic.
    </itemize>

    <item*|Algebramix>

    <\itemize>
      <item>Asymptotically fast implementations for all basic operations on
      univariate (skew) polynomials.

      <item>Several versions of fast multivariate polynomials.
    </itemize>

    <item*|Symbolix>

    <\itemize>
      <item>Basic differential and exterior calculus.

      <item>Efficient manipulation of exp-log expressions and Risch'
      integration algorithm.

      <item>Symbolic interfaces for standard data types, <abbr|i.e.> solve a
      differential equation using power series.
    </itemize>

    <item*|Analyzit>

    <\itemize>
      <item>Systematic implementation of numeric and certified versions of
      standard data types.

      <item>Full library for holonomic and special functions.

      <item>Progress on the subject of effective analytic continuation.
    </itemize>
  </description>

  <section|<with|font-series|bold|How to help>>

  <\itemize>
    <item>Suscribe to the <hlink|developers mailing lists|Devel.html> and
    participate to the design of the language and the elaboration of good
    strategies for writing the compiler.

    <item>Write interfaces for standard mathematical (or other) libraries.

    <item>Help developing the standard libraries.

    <item>Help us writing a compiler for <value|mmx>.
  </itemize>

  <tmdoc-copyright|2003--2005|Joris van der Hoeven>

  <tmdoc-license|Permission is granted to copy, distribute and/or modify this
  document under the terms of the <hlink|GNU General Public
  License|http://www.gnu.org/licenses/gpl.txt>. If you don't have this file,
  write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.>
</body>