AC_DEFUN([AC_LIB_BASIX], [
    PATH="$PATH:$PWD/../basix/src/basix/script"
    AC_MSG_CHECKING([whether basix library is installed])
    AH_TEMPLATE([HAVE_BASIX],[Define if you have the basix library])
    BASIX_CPPFLAGS=`basix-config --cppflags`
    BASIX_LIBS=`basix-config --libs`
    CPPFLAGS="$CPPFLAGS $BASIX_CPPFLAGS"
    LIBS="$LIBS $BASIX_LIBS"
    AC_TRY_LINK(
        [
#include <iostream>
#include <string.hpp>
        ],
        [std::cout << mmx::string ("hallo") << "\n";],
        [AC_DEFINE([HAVE_BASIX],[])],
        AC_MSG_RESULT([no]);AC_MSG_ERROR([missing library: basix]))
    AC_MSG_RESULT([yes])
])

AC_DEFUN([AC_WITH_BASIX], [
    AC_ARG_WITH(basix,
	[  --with-basix=DIR        Basix installation directory],
	with_basix=$withval)

    if test "$with_basix" != ""; then
       PATH="$with_basix/bin:$PATH"
    fi
])
