
/******************************************************************************
* MODULE     : real_ball_glue.cpp
* DESCRIPTION: Standard glue for real balls
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "real_ball.hpp"
#include "floating_meta.hpp"
#include "category_glue.hpp"
namespace mmx {

real_ball make_ball_1 (const floating<>& c) {
  return real_ball (c); }
real_ball make_ball_2 (const floating<>& c, const floating<>& r) {
  return real_ball (c, as<floating<single_floating> > (r)); }

void
define_real_ball () {
  define_type<always,real_ball > ("Real_ball");
  define<always> ("ball", make_ball_1);
  define<always> ("ball", make_ball_2);
  define_field<always,real_ball > ();
  define_elementary<always,real_ball > ();
  define_ordering<always,real_ball > ();
  define_upgrader<always,real_ball,floating<> > (PENALTY_HOMOMORPHISM);
}

} // namespace mmx
