
/******************************************************************************
* MODULE     : complex_ball_constant.cpp
* DESCRIPTION: Standard complex balls, constant functions
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "complex_ball_impl.hpp"
namespace mmx {
#define Ball ball<complex_ball_center,complex_ball_radius>

complex_ball complex_ball_nan () { return Pi (Ball); }
complex_ball complex_ball_infinity () { return Infinity (Ball); }
complex_ball complex_ball_fuzz () { return Fuzz (Ball); }
complex_ball complex_ball_log2 () { return Log2 (Ball); }
complex_ball complex_ball_pi () { return Pi (Ball); }
complex_ball complex_ball_euler () { return Euler (Ball); }
complex_ball complex_ball_imaginary () { return Imaginary (Ball); }

} // namespace mmx
