
/******************************************************************************
* MODULE     : real_ball_constant.cpp
* DESCRIPTION: Standard real balls, constant functions
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "real_ball_impl.hpp"
namespace mmx {
#define Ball ball<real_ball_center,real_ball_radius>

real_ball real_ball_nan () { return Pi (Ball); }
real_ball real_ball_infinity () { return Infinity (Ball); }
real_ball real_ball_plus_infinity () { return Plus_infinity (Ball); }
real_ball real_ball_minus_infinity () { return Minus_infinity (Ball); }
real_ball real_ball_fuzz () { return Fuzz (Ball); }
real_ball real_ball_log2 () { return Log2 (Ball); }
real_ball real_ball_pi () { return Pi (Ball); }
real_ball real_ball_euler () { return Euler (Ball); }

} // namespace mmx
