
/******************************************************************************
* MODULE     : complexify_test.cc
* DESCRIPTION: Test complexified numbers
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "complexify.hpp"
using namespace mmx;

#define Complexify complexify<double>

int
main () {
  Complexify u (7, 3);
  Complexify v (1, 2);
  cout << "u\t= " << u << "\n";
  cout << "v\t= " << v << "\n";
  cout << "conj(u)\t= " << conj(u) << "\n";
  cout << "norm(u)\t= " << norm(u) << "\n";
  cout << "u+v\t= " << u+v << "\n";
  cout << "u-v\t= " << u-v << "\n";
  cout << "v-u\t= " << v-u << "\n";
  cout << "u*v\t= " << u*v << "\n";
  cout << "2*u\t= " << 2*u << "\n";
  cout << "u*2\t= " << u*2 << "\n";
  cout << "u/3\t= " << u/3 << "\n";
  cout << "1/v\t= " << 1/v << "\n";
  cout << "u/v\t= " << u/v << "\n";
  cout << "v/u\t= " << v/u << "\n";
  cout << "(v*v)/u\t= " << (v*v)/u << "\n";
  cout << "u+=v\t= " << (u+=v) << "\n";
  cout << "u-=v\t= " << (u-=v) << "\n";
  cout << "u*=v\t= " << (u*=v) << "\n";
  cout << "u/=v\t= " << (u/=v) << "\n";
  cout << "u*=11\t= " << (u*=11) << "\n";
  cout << "u/=11\t= " << (u/=11) << "\n";
  cout << "u=v\t= " << (u==v) << "\n";
  cout << "u!=v\t= " << (u!=v) << "\n\n";

  cout << "abs(u)=\t" << abs (u) << "\n";
  cout << "arg(u)=\t" << arg (u) << "\n";
  cout << "exp(u)=\t" << exp (u) << "\n";
  cout << "log(u)=\t" << log (u) << "\n";
  cout << "cos(u)=\t" << cos (u) << "\n";
  cout << "sin(u)=\t" << sin (u) << "\n";
  return 0;
}
