
/******************************************************************************
* MODULE     : rational_glue.cpp
* DESCRIPTION: Standard glue for rationals
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "rational_meta.hpp"
#include "category_glue.hpp"
//#include "jet_rational.hpp"
namespace mmx {

/*
static rational*
decode_list (const list<generic>& l) {
  rational* v= mmx_new<rational> (N(l));
  nat i= 0;
  list<generic> counter= l;
  while (!nil (counter)) {
    if (is<integer> (car (counter)))
      v[i]= as<integer> (car (counter));
    else if (is<rational> (car (counter)))
      v[i]= as<rational> (car (counter));
    else ASSERT (false, "rational expected");
    counter= cdr (counter);
    i++;
  }
  return v;
}

static list<generic>
encode_list (rational* v, nat n) {
  list<generic> l;
  for (nat i= n-1; i != ((nat) -1); i--)
    l= cons (as<generic> (v[i]), l);
  return l;
}

static list<generic>
multiply_kronecker (const list<generic>& l1, const list<generic>& l2) {
  rational* v1= decode_list (l1);
  rational* v2= decode_list (l2);
  rational* w = mmx_new<rational> (N(l1)+N(l2)-1);
  kronecker_mul (w, v1, N(l1), v2, N(l2));
  list<generic> m= encode_list (w, N(l1)+N(l2)-1);
  mmx_delete<rational> (v1, N(l1));
  mmx_delete<rational> (v2, N(l2));
  mmx_delete<rational> (w , N(l1)+N(l2)-1);
  return m;
}
*/

integer rational_numerator (const rational& x) { return numerator (x); }
integer rational_denominator (const rational& x) { return denominator (x); }

void
define_rational () {
  define_type<always,rational> ("Rational");
  define_no_flatten<always> ("Rational");
  define_upgrader<always,rational,integer> ();
  define<always> (GEN_NUMERATOR, rational_numerator);
  define<always> (GEN_DENOMINATOR, rational_denominator);

  define_field<always,rational> ();
  define_ordering<always,rational> ();
  define_factorial<always,rational> ();

  //define<always> ("multiply_kronecker", multiply_kronecker);
}

} // namespace mmx
