
/******************************************************************************
* MODULE     : jet_integer.hpp
* DESCRIPTION: Jet_Integers
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX_JET_INTEGER_HPP
#define __MMX_JET_INTEGER_HPP
#include "integer.hpp"
namespace mmx {

template<typename C, typename V, typename K> class multiplier;
struct kronecker_multiply {};

nat  max_bit_size (const integer* src, nat n);
void kronecker_encode (integer& dest, const integer* src, nat n, nat bits);
void kronecker_decode (integer* dest, nat n, nat bits, const integer& src);
void kronecker_mul (integer* dest,
		    const integer* src1, nat n1,
		    const integer* src2, nat n2);

STMPL
class multiplier<integer,kronecker_multiply,integer> {
public:
  static inline void
  mul (integer* d, const integer* s1, const integer* s2, nat n1, nat n2) {
    return kronecker_mul (d, s1, n1, s2, n2); }
};

}
#endif // __MMX_JET_INTEGER_HPP
