
/******************************************************************************
* MODULE     : jet_rational.hpp
* DESCRIPTION: Jet_Rationals
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX_JET_RATIONAL_HPP
#define __MMX_JET_RATIONAL_HPP
#include "rational.hpp"
#include "jet_integer.hpp"
namespace mmx {

integer least_common_denominator (const rational* src, nat n);
void denominator_mul (integer* de, const rational* s, nat n, const integer& d);
void denominator_div (rational* de, const integer* s, nat n, const integer& d);

void kronecker_mul (rational* dest,
		    const rational* src1, nat n1,
		    const rational* src2, nat n2);

STMPL
class multiplier<rational,kronecker_multiply,rational> {
public:
  static inline void
  mul (rational* d, const rational* s1, const rational* s2, nat n1, nat n2) {
    return kronecker_mul (d, s1, n1, s2, n2); }
};

}
#endif // __MMX_JET_RATIONAL_HPP
