
/******************************************************************************
* MODULE     : gnumerix_glue.cpp
* DESCRIPTION: Gnumerix glue library
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "glue.hpp"
namespace mmx {

void define_integer ();
void define_rational ();
void define_floating ();
void define_standard_complexify ();
void define_real_ball ();
void define_complex_ball ();

void
define_standard_gnumerix () {
  define_integer ();
  define_rational ();
  define_floating ();
  define_standard_complexify ();
  define_real_ball ();
  define_complex_ball (); // after real_ball and complexify
}

} // namespace mmx

void (*define_gnumerix) (void)= mmx::define_standard_gnumerix;
