
/******************************************************************************
* MODULE     : gnumerix.cpp
* DESCRIPTION: Basic inclusions, definitions and routines
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "rational.hpp"
#include "glue.hpp"
namespace mmx {

generic
simple_construct_integer (const integer& i) {
  return generic (as_string (i));
}

generic
simple_construct_rational (const rational& x) {
  if (denominator (x) == 1) return generic (as_string (numerator (x)));
  return generic (as_string (numerator (x))) /
         generic (as_string (denominator (x)));
}

/*
void*
gnumerix_malloc (size_t new_size) {
  cout << "[+" << new_size << "]"; cout.flush ();
  return mmx_malloc (new_size);
}

void*
gnumerix_realloc (void* ptr, size_t old_size, size_t new_size) {
  cout << "[" << old_size << "->" << new_size << "]"; cout.flush ();
  return mmx_realloc (ptr, old_size, new_size);
}

void
gnumerix_free (void* ptr, size_t old_size) {
  cout << "[-" << old_size << "]"; cout.flush ();
  mmx_free (ptr, old_size);
}
*/

void
gnumerix_init () {
  mp_set_memory_functions (mmx_malloc, mmx_realloc, mmx_free);
  //mp_set_memory_functions (gnumerix_malloc, gnumerix_realloc, gnumerix_free);
  select_output_evaluator ();  
  define_constructor<always> (simple_construct_integer);
  define_constructor<always> (simple_construct_rational);
  restore_evaluator ();
}

INITIALIZER(gnumerix_init);

} // namespace mmx
