
/******************************************************************************
* MODULE     : big_sum.cpp
* DESCRIPTION: Big commutative sums
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "big_sum.hpp"
#include "generic_internal.hpp"
#include "list_sort.hpp"
namespace mmx {
#define Table table<generic,generic>
#define Iterator iterator<generic>

generic migrate_negate (const generic& g, nat maximal);

/******************************************************************************
* Routines for big sums
******************************************************************************/

generic
flatten (const big_sum& s) {
  const table<generic,generic> sum= *s;
  list<generic> l (entries (sum));
  l= sort (l, big_small_compare);
  generic acc= 0;
  while (!nil (l)) {
    generic mon  = flatten (car (l));
    generic coeff= flatten (sum [car (l)]);
    bool old= set_frac_flag (true);
    acc= acc + coeff * mon;
    (void) set_frac_flag (old);
    l= cdr (l);
  }
  return migrate_negate (acc, 5);
}

Table
sum_to_table (const generic& x) {
  if (is<big_sum> (x)) return *as<big_sum> (x);
  Table t (0);
  if (is_scalar (x)) t[1]= x;
  else t[x]= 1;
  return t;
}

generic
table_to_sum (const Table& t) {
  generic sc= 0;
  Table r (0);
  for (Iterator it= entries (t); busy (it); ++it) {
    generic x= *it;
    if (t[x] == 0);
    else if (is_scalar (x))
      sc= sc + x * t[x];
    else r[x]= t[x];
  }
  if (sc != 0) r[1]= sc;

  if (N(r) == 0) return 0;
  if (N(r) == 1) {
    generic x= *entries (r);
    if (x == 1) return read (r, x);
    if (read (r, x) == 1) return x;
  }
  return as<generic> (big_sum (r));
}

#undef Table
#undef Iterator
} // namespace mmx
